unit Unit_main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics, System.Types, System.StrUtils,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, VclTee.TeeGDIPlus, Vcl.StdCtrls, Vcl.ExtCtrls, VCLTee.TeEngine, VCLTee.TeeProcs, VCLTee.Chart,
  Vcl.ExtDlgs, VCLTEE.Series, VCLTee.TeeEdit;

type
  TForm_Main = class(TForm)
    Chart_Test: TChart;
    Panel1: TPanel;
    Button_ReadData: TButton;
    OpenTextFileDialog1: TOpenTextFileDialog;
    ChartEditor1: TChartEditor;
    Button_ChartEditor: TButton;
    procedure Button_ReadDataClick(Sender: TObject);
    procedure Button_ChartEditorClick(Sender: TObject);
  private
    function CreateLineSerie(MyChart: TChart; SerieName: String): TLineSeries;
    { Private declarations }
  public
    F_XArray : array of array of single;
    F_YArray : array of array of single;
    { Public declarations }
  end;

var
  Form_Main: TForm_Main;

implementation

{$R *.dfm}

procedure TForm_Main.Button_ChartEditorClick(Sender: TObject);
begin
  ChartEditor1.Execute;
end;

procedure TForm_Main.Button_ReadDataClick(Sender: TObject);
var
  DataSetFileName : String;
  Datafile : TStringList;
  NrOfSeries : Integer;
  LineArray : TStringDynArray;
  iline, iSerie, iis : Integer;
  LineSerie : TLineSeries;
  ValueCount : Integer;
begin
  OpenTextFileDialog1.FileName := ExtractFilePath(Application.ExeName) + 'series.txt';

  if OpenTextFileDialog1.execute then begin

    DataSetFileName := OpenTextFileDialog1.FileName;

    DataFile := TStringlist.create;

    if FileExists(DataSetFileName) then begin

      Chart_Test.FreeAllseries;

      DataFile.LoadFromFile(DataSetFileName);

      NrOfSeries := DataFile.Count - 1; // First line is heading

// Create lines and fill arrays.
      for iline := 0 to DataFile.Count - 2 do begin

        LineArray := System.StrUtils.SplitString(DataFile.Strings[iline], ';');

        Caption := iLine.ToString;

        if iline = 0 then begin
          // First line is heading
          NrOfSeries := Length(LineArray) div 2;
          ValueCount := DataFile.Count -1;

          SetLength(F_XArray, NrOfSeries, ValueCount);
          SetLength(F_YArray, NrOfSeries, ValueCount);

          for iSerie := 1 to NrOfSeries do begin
            // create series for Rois
            LineSerie := CreateLineSerie(Chart_Test, 'Line ' + iSerie.ToString);
          end;

        end else begin

          // Fill the Data arrays
          for iSerie := 0 to NrOfSeries - 1 do begin

            iis := (iSerie * 2) + 1;
            if (LineArray[iis] <> '') and (LineArray[iis - 1] <> '') then begin
              F_XArray[iSerie, iline - 1] := LineArray[iis - 1].ToSingle;
              F_YArray[iSerie, iline - 1] := StrToFloat(LineArray[iis]);
            end;

          end;
        end;
      end;

// Add Arrays to the lines.
    for iSerie := 0 to NrOfSeries - 1 do begin
      Chart_Test.Series[iSerie].XValues.Value    := TChartValues(F_XArray[iSerie]);
      Chart_Test.Series[iSerie].XValues.Modified := True;
      Chart_Test.Series[iSerie].XValues.Count    := ValueCount;

      Chart_Test.Series[iSerie].YValues.Value    := TChartValues(F_YArray[iSerie]);
      Chart_Test.Series[iSerie].YValues.Modified := True;
      Chart_Test.Series[iSerie].YValues.Count    := ValueCount;

    end;

    end else begin
      ShowMessage('Dataset : ' + DataSetFileName + ' not found');
    end;

    DataFile.Free;
  end;

end;

function TForm_Main.CreateLineSerie(MyChart: TChart; SerieName : String): TLineSeries;
begin
  Result := TLineSeries.Create(MyChart);

  Result.ParentChart := MyChart;

  Result.Title := SerieName;

  Result.Linepen.Color     := clTeal;
  Result.SeriesColor       := clTeal;
  Result.Pointer.Visible   := true;
  Result.Pointer.Style     := psDiamond;
  Result.Pointer.HorizSize := 3;
  Result.Pointer.VertSize  := 3;
  Result.Linepen.Visible   := true;
  Result.Active            := true;
  Result.Cursor            := crHandpoint;
  Result.ShowInLegend      := False;

  Result.DrawStyle     := dsAll;
  Result.XValues.Order := loNone;
  Result.YValues.Order := loNone;
end;

end.
